package com.qmth.sop.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.qmth.sop.business.bean.result.TBDeviceDeliveryResult;
import com.qmth.sop.business.entity.TBDeviceDelivery;
import com.qmth.sop.common.enums.DeviceDeliveryStatusEnum;
import com.qmth.sop.common.enums.DeviceUsageTypeEnum;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 设备发货表 Mapper 接口
 * </p>
 *
 * @author wangliang
 * @since 2023-11-28
 */
public interface TBDeviceDeliveryMapper extends BaseMapper<TBDeviceDelivery> {

    /**
     * 设备发货分页查询
     *
     * @param iPage            iPage
     * @param serviceId        serviceId
     * @param usageType        usageType
     * @param crmNo            crmNo
     * @param status           status
     * @param deliverUserId    deliverUserId
     * @param deliverStartTime deliverStartTime
     * @param deliverEndTime   deliverEndTime
     * @param serialNo         serialNo
     * @param supplierId       supplierId
     * @param receiveStartTime receiveStartTime
     * @param receiveEndTime   receiveEndTime
     * @return 查询结果
     */
    IPage<TBDeviceDeliveryResult> page(IPage<Map> iPage,
                                       @Param("serviceId") Long serviceId,
                                       @Param("usageType") DeviceUsageTypeEnum usageType,
                                       @Param("crmNo") String crmNo,
                                       @Param("status") DeviceDeliveryStatusEnum status,
                                       @Param("deliverUserId") Long deliverUserId,
                                       @Param("deliverStartTime") Long deliverStartTime,
                                       @Param("deliverEndTime") Long deliverEndTime,
                                       @Param("serialNo") String serialNo,
                                       @Param("supplierId") Long supplierId,
                                       @Param("receiveStartTime") Long receiveStartTime,
                                       @Param("receiveEndTime") Long receiveEndTime);

    /**
     * 设备发货列表查询
     *
     * @param serviceId        serviceId
     * @param usageType        usageType
     * @param crmNo            crmNo
     * @param status           status
     * @param deliverUserId    deliverUserId
     * @param deliverStartTime deliverStartTime
     * @param deliverEndTime   deliverEndTime
     * @param serialNo         serialNo
     * @param supplierId       supplierId
     * @param receiveStartTime receiveStartTime
     * @param receiveEndTime   receiveEndTime
     * @return 查询结果
     */
    List<TBDeviceDeliveryResult> list(@Param("serviceId") Long serviceId,
                                      @Param("usageType") DeviceUsageTypeEnum usageType,
                                      @Param("crmNo") String crmNo,
                                      @Param("status") DeviceDeliveryStatusEnum status,
                                      @Param("deliverUserId") Long deliverUserId,
                                      @Param("deliverStartTime") Long deliverStartTime,
                                      @Param("deliverEndTime") Long deliverEndTime,
                                      @Param("serialNo") String serialNo,
                                      @Param("supplierId") Long supplierId,
                                      @Param("receiveStartTime") Long receiveStartTime,
                                      @Param("receiveEndTime") Long receiveEndTime);
}
